package cn.iocoder.yudao.module.pms.service.depttype;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;
import cn.iocoder.yudao.module.pms.controller.admin.depttype.vo.IotDeptTypePageReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.depttype.vo.IotDeptTypeSaveReqVO;
import cn.iocoder.yudao.module.pms.dal.dataobject.depttype.IotDeptTypeDO;
import cn.iocoder.yudao.module.pms.dal.mysql.depttype.IotDeptTypeMapper;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.pms.enums.ErrorCodeConstant.IOT_DEPT_TYPE_NOT_EXISTS;

/**
 * 部门类型 Service 实现类
 *
 * @author rq
 */
@Service
@Validated
public class IotDeptTypeServiceImpl implements IotDeptTypeService {

    @Resource
    private IotDeptTypeMapper iotDeptTypeMapper;

    @Override
    public Long createIotDeptType(IotDeptTypeSaveReqVO createReqVO) {
        // 插入
        IotDeptTypeDO iotDeptType = BeanUtils.toBean(createReqVO, IotDeptTypeDO.class);
        iotDeptTypeMapper.insert(iotDeptType);
        // 返回
        return iotDeptType.getId();
    }

    @Override
    public void updateIotDeptType(IotDeptTypeSaveReqVO updateReqVO) {
        // 校验存在
        validateIotDeptTypeExists(updateReqVO.getId());
        // 更新
        IotDeptTypeDO updateObj = BeanUtils.toBean(updateReqVO, IotDeptTypeDO.class);
        iotDeptTypeMapper.updateById(updateObj);
    }

    @Override
    public void deleteIotDeptType(Long id) {
        // 校验存在
        validateIotDeptTypeExists(id);
        // 删除
        iotDeptTypeMapper.deleteById(id);
    }

    private void validateIotDeptTypeExists(Long id) {
        if (iotDeptTypeMapper.selectById(id) == null) {
            throw exception(IOT_DEPT_TYPE_NOT_EXISTS);
        }
    }

    @Override
    public IotDeptTypeDO getIotDeptType(Long id) {
        return iotDeptTypeMapper.selectById(id);
    }

    @Override
    public PageResult<IotDeptTypeDO> getIotDeptTypePage(IotDeptTypePageReqVO pageReqVO) {
        return iotDeptTypeMapper.selectPage(pageReqVO);
    }

}